/*
 * ter un Robot-Car en Bluetooth avec un Smartphone Android ONLY
 * Application Bluetooth RC Controller
 * Alimenter 6 x piles 1,2v 2500mA = 7.8v
 * HC-05 - RXD en D1, TXD en D0, VCC en +5v ,GND en GND
 * L298n - ENA en D11, IN1 en D13, IN2 en D12, IN3 en D8, IN4 en D7, ENB en D6 
 * Feux AV en D2, Feux AR en D3, Klaxon en D4
*/

int ena = 11;  //Moteur A
int in1 = 13;
int in2 = 12;
int in3 = 8;  //Moteur B
int in4 = 7;
int enb = 6;

int valeur_PWM = 0; // variable PWM de 0 à 255
char t;
int feuAV = 2;  // broche feu AV
int feuAR = 3;  // broche feu AR
int klaxon = 4; // broche klaxon AV
int Tempo=200;

void setup() {
  pinMode(in1, OUTPUT);
  pinMode(in2, OUTPUT);
  pinMode(in3, OUTPUT);
  pinMode(in4, OUTPUT);
  pinMode(ena, OUTPUT);
  pinMode(enb,OUTPUT);
  pinMode(feuAV,OUTPUT);
  pinMode(feuAR,OUTPUT);
  pinMode(klaxon,OUTPUT);
  Serial.begin(9600);
}

void loop() {
  if (Serial.available()>0) {
    t = Serial.read();
    Serial.println(t);
       
    switch (t) {
      /*  Calcul de la tension moteur avec pile 7.8v => (7.8v/255)*valeur_PWM
          en dessous de 3.8v les moteurs ne tournent pas( Moteur mini +3v)
          On constate une réelle différence entre la tension calculée 
          et la tension réelle mesurée 
      */
      case '0':valeur_PWM = 0;break; //Calcul 0v => Pas assez de tension
      case '1':valeur_PWM = 128;break; //Calcul 0.76v => Pas assez de tension
      case '2':valeur_PWM = 128;break; //Calcul 1.56v => Pas assez de tension
      case '3':valeur_PWM = 156;break; //Calcul 2.32v => Pas assez de tension
      case '4':valeur_PWM = 156;break; //Calcul 3.12v => Pas assez de tension
      case '5':valeur_PWM = 184;break; //Calcul 3.88v => Réel environ 3.1v
      case '6':valeur_PWM = 184;break; //Calcul 4.68v => Réel environ 3.8v
      case '7':valeur_PWM = 212;break; //Calcul 5.44v => Réel environ 4.2v
      case '8':valeur_PWM = 212;break; //Calcul 6.24v => Réel environ 4.8v
      case '9':valeur_PWM = 255;break; //Calcul 7v => Réel environ 5v
      case 'q':valeur_PWM = 255;break; //Calcul 7.8v => Réel environ 5.5v
      }
      analogWrite(ena,valeur_PWM);
      analogWrite(enb,valeur_PWM);
// Les Moteurs
if(t == 'F'){            //AV 13-8 - lettre F
  digitalWrite(in1,HIGH);
  digitalWrite(in2,LOW);
  analogWrite(ena,valeur_PWM);  //PWM
  digitalWrite(in3,HIGH);
  digitalWrite(in4,LOW);
  analogWrite(enb,valeur_PWM);  //PWM
}
else if(t == 'B'){      //AR 12-7 - lettre B
  digitalWrite(in1,LOW);
  digitalWrite(in2,HIGH);
  analogWrite(ena,valeur_PWM);  //PWM
  digitalWrite(in3,LOW);
  digitalWrite(in4,HIGH);
  analogWrite(enb,valeur_PWM);  //PWM
}
else if(t == 'L'){      //DROITE 12-8 - lettre L
  digitalWrite(in1,LOW);
  digitalWrite(in2,HIGH); 
  analogWrite(ena,valeur_PWM);  //PWM
  digitalWrite(in3,HIGH);
  digitalWrite(in4,LOW);
  analogWrite(enb,valeur_PWM);  //PWM
}
else if(t == 'R'){      //GAUCHE 13-7 - lettre R
  digitalWrite(in1,HIGH);
  digitalWrite(in2,LOW);
  analogWrite(ena,valeur_PWM);  //PWM
  digitalWrite(in3,LOW);
  digitalWrite(in4,HIGH);
  analogWrite(enb,valeur_PWM);  //PWM
}
else if(t == 'S'){      //STOP (all motors stop)= S - Lettre S
  digitalWrite(in1,LOW);
  digitalWrite(in2,LOW);
  digitalWrite(in3,LOW);
  digitalWrite(in4,LOW);
}
delay(100);
}

// Feux AV et AR
else if(t == 'W'){      //Feu AV ON = W - Lettre W
  digitalWrite(feuAV,HIGH);
}
else if(t == 'w'){      //Feu AV Off = w - Lettre w (petit)
  digitalWrite(feuAV,LOW);
}
else if(t == 'U'){      //Feu AR ON = U - Lettre U
  digitalWrite(feuAR,HIGH);
}
else if(t == 'u'){      //Feu AR Off = X - Lettre u (petit)
  digitalWrite(feuAR,LOW);
}
else if(t == 'X'){      //Warning ON = X
  digitalWrite(feuAV,HIGH);
  digitalWrite(feuAR,HIGH);
  delay(100);
  digitalWrite(feuAV,LOW);
  digitalWrite(feuAR,LOW);
  delay(100);  
}
else if(t == 'x'){      //Warning Off = x - Lettre u (petit)
  digitalWrite(feuAV,LOW);
  digitalWrite(feuAR,LOW);
}

// Klaxon
else if(t == 'V'){      //Klaxon On = V - lettre V
  tone(klaxon,750,250); // tone(pin,frequence,durée);
  delay(Tempo);
  tone(klaxon, 1000,250);
  delay(Tempo);
  tone(klaxon, 900,250);
  delay(Tempo);
}
else if(t == 'v'){      //Klaxon Off = v - Lettre v (petit)
  //digitalWrite(klaxon,LOW);
  noTone(klaxon);
}
delay(100);
}
